// GlobalMemoryStatus.cpp : Defines the entry point for the application.
//
// Volendo si possono commentare le ultime due funzioni (la strlen e la WinMainCRTStartup)
// ed usare quelle messe a disposizione della libctiny.lib, da aggiungere nelle librerie
// da linkare al progetto nell'apposita spazio delle opzioni del linker.
// le opzioni /MERGE:.idata=.data /MERGE:.data=.text che servono a fondere insieme queste sezioni
// del PE non funzionano con la libctiny (da esplorare il perche', ma sicuramente il fatto  legato
// al flag delle sezioni (6000040 invece di c000040, quindi niente scrittura)
// Con /ALIGN:512 si allineano le sezioni del pe ad un boundary di 512Byte (si risparmia spazio sull'hd)
// e questa direttiva funziona sia col libctiny che senza.

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100
#define TIMER_SEC 1				//ID del mio TIMER
#define ID_GATTOBTN  1001		//ID del bottone "GATTO"
#define ID_GATTOBAR  1002		//ID della STATUSBAR
#define LWA_ALPHA 0x00000002	//Per l'ALPHA BLENDING (Trasparenza) della finestra

//handler flags settings, sono nel file /CRT/EXSUP.INC del tree di VisualC++
//#define EXCEPTION_UNWINDING     0x02
//#define EXCEPTION_EXIT_UNWIND   0x04
//#define EXCEPTION_UNWIND_CONTEXT (EXCEPTION_UNWINDING | EXCEPTION_EXIT_UNWIND)

// rinomina la .code in .mrcode, non serve a nulla ma e' bellino :)
#pragma code_seg (".mrcode")
//allinea il file e le sezioni a 16 byte invece che a 4k, pero' l'exe funzioner solo su nt/2k/xp
#pragma comment(linker,"/FILEALIGN:0x20 /ALIGN:0x20")
//fonde insieme le varie sezioni in una unica a cui modifica gli attributi (la .data deve avere "W")
#pragma comment(linker,"/MERGE:.data=.mrcode /MERGE:.rdata=.mrcode /MERGE:.text=.mrcode /SECTION:.mrcode,EWR") 
//ignora i warning per la rinominazione delle sezioni e dello stub e cambia l'entrypoint alla mia funzione
#pragma comment(linker,"/IGNORE:4078,4060 /ENTRY:WinMiao")
//rilocazione della base, /release mette il checksum nel campo apposito del PE e /version la versione dell'exe
#pragma comment(linker,"/BASE:0x6130000 /RELEASE /VERSION:1.1")
//linka uno stub minimo di 64byte, altrimenti mette lo stub di default che sono 512byte in piu'!!
//poi chiedo anche di non includere i dati mai referenziati all'interno del mio programma
#pragma comment(linker,"/STUB:MINISTUB.BIN /OPT:REF") 

// Variabili Globali:
HINSTANCE hInst;						// Instanza Corrente
TCHAR szTitle[MAX_LOADSTRING];			// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];	// The title bar text
HWND btgatto, statbar;

//variabili usate per contare i millisecondi di durata della OnPaint().
LARGE_INTEGER TSC1,TSC2,FREQ;
double msecs;

//Oggetti globali usati con la GDIPlus
Image* image;							// Variabile Globale (immagine di sfondo da caricare)
FontFamily *fontFamily;					// una volta inizializzata la GDI+
Font *font;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

// Questa  la gestione vectored dell'SEH disponibile solo su XP e 2K
// interviene PRIMA della gestione di sistema.

LONG __stdcall VectoredHandler(
    struct _EXCEPTION_POINTERS *ExceptionInfo
    )
{
    TCHAR excpstr[MAX_LOADSTRING];

	StringCbPrintf(excpstr, MAX_LOADSTRING, "*ERRORE* \nException Code: %08X \nException Flags: %X \nException Address: %08X",
             ExceptionInfo->ExceptionRecord->ExceptionCode, ExceptionInfo->ExceptionRecord->ExceptionFlags, ExceptionInfo->ExceptionRecord->ExceptionAddress);
	
	MessageBox(NULL, excpstr,"Gestore interno VectoredSEH", MB_OK );
    return EXCEPTION_CONTINUE_SEARCH;
}


// Alternativa alla classica WinMain()....il programma  dedicato al gatto, quindi....;)
int APIENTRY WinMiao(void)
{
 	
	MSG msg;
	PVOID vecthndl1;	//puntatore all'handle della funzione VectoredHandleSEH
	
	GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR           gdiplusToken;
	int nCmdShow=SW_SHOWDEFAULT;
	
	// aggiungo il mio handler alla lista di sistema, questo handler interviene PRIMA di quello di win
	vecthndl1 = AddVectoredExceptionHandler(1,VectoredHandler); 
	HINSTANCE hInstance=GetModuleHandle(NULL);
	
	// con questa istruzione tutti gli errori li devo gestire io
	// con un mio handler!!, non poppa nulla! evvai...:-)
	
	SetErrorMode(SEM_NOGPFAULTERRORBOX);
	
	
	//provate a commentare questa linea di codice e vederete intervenire il vostro Handler :)
	//*(PDWORD)0 = 0;             // Write to address 0 to cause a fault
	
	//Converte in msecs il counter
	QueryPerformanceFrequency(&FREQ), FREQ.QuadPart /= 1000;

	// Inizializza GDI+.
    GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);

	//adesso posso associare al puntatore alla variabile globale l'immagine di sfondo
	image = new Image(L"Bimbo.jpg");
	fontFamily = new FontFamily(L"Arial");
	font = new Font(fontFamily, 12, FontStyleRegular, UnitPixel);
	
	// Inizializza COMCTL32 (ma il manifest funziona anche senza questo init)
	//commonctrl.dwSize = sizeof (INITCOMMONCONTROLSEX);
	//commonctrl.dwICC = ICC_STANDARD_CLASSES;
	//InitCommonControlsEx(&commonctrl);
	InitCommonControls();		//funziona anche cos e risparmio un pochino
								//anche se salto l'init delle classi che voglio registrare
		
	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_GLOBALMEMORYSTATUS, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		{
			//TranslateMessage(&msg); questa serve solo per i messaggi di tipo WM_CHAR
			DispatchMessage(&msg);
		}
	}
	
	// Shutdown del GDI+	
	GdiplusShutdown(gdiplusToken);
	
	// rimuovo l'handler dalla lista di sistema
	RemoveVectoredExceptionHandler(vecthndl1); 
	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_DBLCLKS | CS_DROPSHADOW; //la finestra proietta l'ombra sulle altre
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_GLOBALMEMORYSTATUS);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= NULL;//(HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_GLOBALMEMORYSTATUS;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindowEx(WS_EX_LAYERED, szWindowClass, szTitle, WS_OVERLAPPEDWINDOW ,
      CW_USEDEFAULT, CW_USEDEFAULT, 308, 302, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }
   
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   //Setto la trasparenza della finestra al 100% (Solida) se mettete qualcosa tipo:
   //SetLayeredWindowAttributes(hWnd, 0, 255 * 50/100 , LWA_ALPHA );	
   //allora la finestra sar semitrasparente (50%), simpatico eh? =)

   SetLayeredWindowAttributes(hWnd, 0, 255 * 100/100 , LWA_ALPHA );
     
   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//

//-----------------------------------------------------------------------------
// Name: CreateMyTooltip (non e' roba mia)
// Desc: crea un tooltip sull'intera area del controllo che gli viene passato
//-----------------------------------------------------------------------------
void CreateMyTooltip (HWND hwnd, HINSTANCE ghThisInstance, LPSTR lptstr)
{
	HWND hwndTT;                // handle to the ToolTip control
								// struct specifying info about tool in ToolTip control
    TOOLINFO ti;
    unsigned int uid = 0;       // for ti initialization
    
    RECT rect;                  // for client area coordinates

    /* CREATE A TOOLTIP WINDOW */
    hwndTT = CreateWindowEx(WS_EX_TOPMOST,
        TOOLTIPS_CLASS,
        NULL,
        WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,		
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        hwnd,
        NULL,
        ghThisInstance,
        NULL
        );

    SetWindowPos(hwndTT,
        HWND_BOTTOM,
        0,
        0,
        0,
        0,
        SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

    /* GET COORDINATES OF THE MAIN CLIENT AREA */
    GetClientRect (hwnd, &rect);

    /* INITIALIZE MEMBERS OF THE TOOLINFO STRUCTURE */
    ti.cbSize = sizeof(TOOLINFO);
    ti.uFlags = TTF_SUBCLASS;
    ti.hwnd = hwnd;
    ti.hinst = ghThisInstance;
    ti.uId = uid;
    ti.lpszText = lptstr;
        // ToolTip control will cover the whole window
    ti.rect.left = rect.left;    
    ti.rect.top = rect.top;
    ti.rect.right = rect.right;
    ti.rect.bottom = rect.bottom;

    /* SEND AN ADDTOOL MESSAGE TO THE TOOLTIP CONTROL WINDOW */
    SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	

}

// DoCreateStatusBar - creates a status bar and divides it into
// the specified number of parts.
// Returns the handle to the status bar.
// hwndParent - parent window for the status bar.
// nStatusID - child window identifier.
// hinst - handle to the application instance.
// nParts - number of parts into which to divide the status bar.

HWND DoCreateStatusBar(HWND hwndParent, int nStatusID, HINSTANCE
                      hinst, int nParts)
{
    HWND hwndStatus;
    RECT rcClient;
    HLOCAL hloc;
    LPINT lpParts;
    int i, nWidth;

    // Create the status bar.
    hwndStatus = CreateWindowEx(
        0,                       // no extended styles
        STATUSCLASSNAME,         // name of status bar class
        (LPCTSTR) NULL,          // no text when first created
        SBARS_SIZEGRIP |         // includes a sizing grip
        WS_CHILD | WS_VISIBLE,   // creates a child window
        0, 0, 0, 0,              // ignores size and position
        hwndParent,              // handle to parent window
        (HMENU) nStatusID,       // child window identifier
        hinst,                   // handle to application instance
        NULL);                   // no window creation data

    // Get the coordinates of the parent window's client area.
    GetClientRect(hwndParent, &rcClient);
	
    // Allocate an array for holding the right edge coordinates.
    hloc = LocalAlloc(LHND, sizeof(int) * nParts);
    lpParts = (int *)LocalLock(hloc);

    // Calculate the right edge coordinate for each part, and
    // copy the coordinates to the array.
    nWidth = rcClient.right / nParts;
    for (i = 0; i < nParts; i++) { 
       lpParts[i] = nWidth;
       nWidth += nWidth;
    }

    // Tell the status bar to create the window parts.
    SendMessage(hwndStatus, SB_SETPARTS, (WPARAM) nParts, (LPARAM)
               lpParts);
	
	// Free the array, and return.
    LocalUnlock(hloc);
    LocalFree(hloc);
    return hwndStatus;
}  



#define DIV 1024

//-----------------------------------------------------------------------------
// Name: Draw
// Desc: chiamata dalla OnPaint() per disegnare sulla client area della finestra.
//-----------------------------------------------------------------------------

void Draw(Graphics* pGraphics, int nWidth, int nHeight)
    {
        WCHAR szHello[MAX_LOADSTRING];
		MEMORYSTATUS stat;
		char *divisor = "K";
		
		//coordinate da cui iniziare a scrivere
		PointF      pointF(10.0f, 10.0f);
		
		//fill background
        SolidBrush solidBrush(Color(255, 255, 255));
		pGraphics->FillRectangle(&solidBrush, 0, 0, nWidth, nHeight);
		
		//Image image(L"Bimbo.jpg");
		pGraphics->DrawImage(image, 0, 0);
		
		//Funzione che recupera lo stato della memoria di sistema
		GlobalMemoryStatus (&stat);

		//stampo le informazioni a schermo
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"The MEMORYSTATUS structure is %ld bytes long",stat.dwLength);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);
		
		pointF.Y=30.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There is %ld percent of memory in use.",stat.dwMemoryLoad);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		pointF.Y=50.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld total %sbytes of physical memory.",stat.dwTotalPhys/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		pointF.Y=70.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld free %sbytes of physical memory.",stat.dwAvailPhys/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);
		
		pointF.Y=90.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld total %sbytes of paging file.",stat.dwTotalPageFile/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		pointF.Y=110.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld free %sbytes of paging file.",stat.dwAvailPageFile/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		pointF.Y=130.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld total %sbytes of virtual memory.",stat.dwTotalVirtual/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		pointF.Y=150.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"There are %ld free %sbytes of virtual memory.",stat.dwAvailVirtual/DIV, divisor);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);

		//stampo anche quanti millisecondi ci ho messo a fare tutte queste cosette 
		pointF.Y=170.0f;
		StringCbPrintfW (szHello, MAX_LOADSTRING, L"Durata OnPaint(): %6.3f msecs", msecs);
		pGraphics->DrawString(szHello, -1, font, pointF, &solidBrush);
		
		      		
    }


//-----------------------------------------------------------------------------
// Name: OnPaint
// Desc: in caso di WM_PAINT viene chiamata questa funzione, ed usa GDI+
//		 per disegnare sulla client area della finestra.
//-----------------------------------------------------------------------------

LRESULT OnPaint(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
    {
        
        HDC hdc;
		RECT rect;			
		PAINTSTRUCT ps;
		        
		GetClientRect(hWnd,&rect);
        
		int nWidth = rect.right - rect.left + 1;
        int nHeight = rect.bottom - rect.top + 1;
        
		hdc = BeginPaint(hWnd,&ps);
		        
		Graphics graphics(hdc);
        		      
		//memory bitmap 
        Bitmap* pMemBitmap = new Bitmap(nWidth, nHeight);
		
        //offscreen graphics
        Graphics* pMemGraphics = graphics.FromImage(pMemBitmap);
		
		//draw to memory bitmap
		Draw(pMemGraphics, nWidth, nHeight);
        
		CachedBitmap cBitmap(pMemBitmap, &graphics);
		
		// draw from memory bitmap to window
        graphics.DrawCachedBitmap(&cBitmap, 0, 0);
		
		delete pMemGraphics;
        delete pMemBitmap;
				
		EndPaint(hWnd, &ps);      
		
		return 0;
    
}

//-----------------------------------------------------------------------------
// Name: GetEncoderClsid
// Desc: ritorna l'ID dell'encoder richiesto come parametro stringa
//-----------------------------------------------------------------------------
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( strcmpi((const char*)pImageCodecInfo[j].MimeType, (const char*)format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}

//-----------------------------------------------------------------------------
// Name: Convert
// Desc: Converte da bmp a png tramite la libreria gdiplus
//-----------------------------------------------------------------------------
Status Convert (void)
{
	Status stato;
	CLSID  encoderClsid;

	// Get the CLSID of the PNG encoder.
	GetEncoderClsid(L"image/png", &encoderClsid);
	stato = image->Save(L"Bimbo.png", &encoderClsid, NULL);
	if(stato != Ok) MessageBox(NULL,"Errore di conversione","Convert",MB_OK);
		
	return stato;
}

//-----------------------------------------------------------------------------
// Name: CloseSmoothly
// Desc: Chiude la finestra col fadeout
//-----------------------------------------------------------------------------
void CloseSmoothly(HWND hWnd)
{
	// Incrementa la trasparenza 1% ad ogni iterazione
	for(int nPercent=100; nPercent >= 0; nPercent--)
		SetLayeredWindowAttributes(hWnd, 0, 255 * nPercent/100, LWA_ALPHA);

}

//-----------------------------------------------------------------------------
// Name: WndProc
// Desc: Gestisce i vari messaggi del sistema
//-----------------------------------------------------------------------------

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
				
	switch (message) 
	{
		case WM_CREATE:
          //Faccio partire un timer di refresh della durata di 1 secondo
		  SetTimer (hWnd, TIMER_SEC, 1000, NULL) ;

		  //creo i vari bottoni, con relativi tooltips e li inizializzo
		  if(!btgatto) { btgatto=CreateWindowEx(NULL,"Button","&Gatto",WS_CHILD | WS_VISIBLE,90,190,125,25,hWnd,(HMENU)ID_GATTOBTN, hInst,0);
						 CreateMyTooltip(btgatto, hInst, "Miaoooo!!!");
						 statbar=DoCreateStatusBar(hWnd, ID_GATTOBAR, hInst, 2);
						 SendMessage(statbar, SB_SETTEXT, (WPARAM) 0, (LPARAM)"GlobalMemoryStatus()");
						 SendMessage(statbar, SB_SETTEXT, (WPARAM) 1, (LPARAM)"(C)MrCode 2004");
						 CreateMyTooltip(statbar, hInst, "StatusBar divisa in due sezioni");
						}
		  break;
	
		case WM_TIMER :
			switch(wParam){
			case TIMER_SEC:
				InvalidateRect (hWnd, NULL, FALSE) ; // forza un repaint
				break;
			default:
				break;
			}
          break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case ID_GATTOBTN:
				case IDM_EXIT:
				   KillTimer(hWnd, TIMER_SEC);  // spengo il timer
				   CloseSmoothly(hWnd);			// chiudo con effetto fading
				   DestroyWindow(hWnd);			// chiudo definitivamente la finestra
				   break;
				case IDM_CONVERT_EXECUTE:
				   Convert();					// converto l'immagine in PNG e la salvo
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}

			break;

		case WM_PAINT:
			//Funzione che usa GDI+ con tecnica di double buffering
			//e viaggia alla grande!!...alla "grandna" vai....
			
			//debug, cicli necessari per copiare a video
			QueryPerformanceCounter(&TSC1);

			//Routine che si occupa del disegno a video
			OnPaint(hWnd, message, wParam, lParam);
			
			//debug, cicli necessari per copiare a video
			QueryPerformanceCounter(&TSC2);		

			//converto tutto in millisecondi per poterli poi stampate
			msecs=((double)TSC2.QuadPart-(double)TSC1.QuadPart)/FREQ.QuadPart;

			break;
	
		case WM_ERASEBKGND:
			//qui  fondamentale dire a Win che non voglio fare nulla
			//quindi lascio stare cos (la gestione del messaggio  questa)
			return FALSE;
			
		case WM_DESTROY:
			KillTimer (hWnd, TIMER_SEC) ; // ferma il timer dell'aggiornamento della memoria
			PostQuitMessage(0);			  // vogliamo uscire!
			break;
		
		case WM_SIZE:		
			SendMessage(statbar, WM_SIZE, wParam, lParam); // resize della status bar
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


//-----------------------------------------------------------------------------
// Name: strcmpi()
// Desc: replace original libc.lib routine (ignore default library switch ON)
//-----------------------------------------------------------------------------

extern "C" int __cdecl strcmpi(const char *s1, const char *s2)
{
    return lstrcmpi( s1, s2 );
}

//-----------------------------------------------------------------------------
// Name: SEH
// Desc: replace original libc.lib routine (ignore default library switch ON)
// ho deciso di togliere il supporto per il SEH per risparmiare ulteriori byte
// tanto per gestire le eccezioni rimane comunque il per process handler di sistema
// quindi se crashavo prima....crasho anche ora ma con l'exe + piccino
// Courtesy of Andreageddon
//-----------------------------------------------------------------------------
